//+------------------------------------------------------------------+
//|                                              Globals_test_EA.mq5 |
//|                                           Copyright 2014, denkir |
//|                           https://login.mql5.com/ru/users/denkir |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, denkir"
#property link      "https://login.mql5.com/ru/users/denkir"
#property version   "1.00"
#define GVARS_LIST_SIZE 6
//--- include
#include "CGlobalVarList.mqh"

//--- globals
CGlobalVarList gvarList;
//---  : 
string gVar_names[6]=
  {
   "gvarOpen_start","gvarOpen_finish",
   "gvarClose_start","gvarClose_finish",
   "gvarTrail_start","gvarTrail_finish"
  };
//--- test
bool gToLog=false;
string curr_module=": ";
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---   gvarList   CGlobalVar
   for(int idx=0;idx<GVARS_LIST_SIZE;idx++)
     {
      ResetLastError();
      CGlobalVar *ptr_gVar=new CGlobalVar;
      //---
      if(CheckPointer(ptr_gVar)==POINTER_DYNAMIC)
        {
         ResetLastError();
         //--- try to add
         if(gvarList.Add(ptr_gVar)>-1)
            continue;
         //---  
         PrintFormat("Failed to add a new gvar: %d",_LastError);
         return INIT_FAILED;
        }
      //---  
      PrintFormat("Failed to create a new gvar: %d",_LastError);
      return INIT_FAILED;
     }
//--- \  
   for(int idx=0;idx<GVARS_LIST_SIZE;idx++)
     {
      CGlobalVar *ptr_gVar=gvarList.GetNodeAtIndex(idx);
      if(ptr_gVar!=NULL)
        {
         //---   gvar    
         if(!ptr_gVar.Create(gVar_names[idx]))
            //---    gvar
            if(ptr_gVar.IsGlobalVar(gVar_names[idx]))
              {
               double val=0.0;
               val=ptr_gVar.GetValue(val);
               if(val==1.)
                 {
                  string module_name=StringSubstr(gVar_names[idx],4);
                  Print("  : <<"+module_name+">>");
                 }
              }
        }
     }

//---
   return INIT_SUCCEEDED;
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   Comment("");

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   Main();
  }
//+------------------------------------------------------------------+
//| Main module                                                      |
//+------------------------------------------------------------------+
void Main(void)
  {
//---     
   for(int idx=0;idx<GVARS_LIST_SIZE;idx++)
      SetFlag(idx,false);

//---       
//---   
   if(TerminalInfoInteger(TERMINAL_TRADE_ALLOWED))
      //---    
      if(TerminalInfoInteger(TERMINAL_CONNECTED))
         //---      
         if(MQLInfoInteger(MQL_TRADE_ALLOWED))
           {
            //--- 1)  
            Open();
            //--- 2)  
            Close();
            //--- 3)  
            Trail();
           }
  }
//+------------------------------------------------------------------+
//| Open module                                                      |
//+------------------------------------------------------------------+
void Open(void)
  {
   Comment(curr_module+__FUNCTION__);
//---
   if(!IsStopped())
     {
      //---    
      SetFlag(0,true);

      //--- ,    2 
        {
         Sleep(2000);
        }
      //---    
      SetFlag(1,true);
     }
  }
//+------------------------------------------------------------------+
//| Close module                                                     |
//+------------------------------------------------------------------+
void Close(void)
  {
   Comment(curr_module+__FUNCTION__);
//---
   if(!IsStopped())
     {
      //---    
      SetFlag(2,true);
      //--- ,    1.5 
        {
         Sleep(1500);
        }
      //---    
      SetFlag(3,true);
     }
  }
//+------------------------------------------------------------------+
//| Trailing module                                                  |
//+------------------------------------------------------------------+
void Trail(void)
  {
   Comment(curr_module+__FUNCTION__);
//---
   if(!IsStopped())
     {
      //---    
      SetFlag(4,true);
      //--- ,    0.75 
        {
         Sleep(750);
        }
      //---    
      SetFlag(5,true);
     }
  }
//+------------------------------------------------------------------+
//| /                        |
//+------------------------------------------------------------------+
void SetFlag(const int _idx,const bool _to_reset)
  {
   string module_name=StringSubstr(gVar_names[_idx],4);

//---     
   if(!IsStopped())
     {
      //---    
      CGlobalVar *ptr_gVar=gvarList.GetNodeAtIndex(_idx);
      if(ptr_gVar!=NULL)
         //---    gvar
         if(ptr_gVar.IsGlobalVar(gVar_names[_idx]))
           {
            double val=1.0;
            if(_to_reset)
               val=0.0;
            if(!ptr_gVar.Value(val))
               Print("    : <<"+module_name+">>");
           }
     }
   else
      Print("    : <<"+module_name+">>");
  }
//+------------------------------------------------------------------+
